/*
xml from bersirc
*/

#ifndef _CLARO_EU_H
#define _CLARO_EU_H
/** \defgroup _CLARO_EU_
 * \brief The _CLARO_EU_
 * @{
 */
#include <claro/base.h>
#include <claro/graphics.h>
#include <claro/graphics/platform.h>

#ifdef WINVER
CLFEXP HWND obj_to_hwnd( object_t * object ); 
CLFEXP HDC obj_to_hdc( object_t * object ); 
#endif

#ifndef NO_CAIRO
#include <cairo.h>

/**
 * \brief obj_to_ the  Canvas widget object
 * 
 * \param widget A valid object.
 */
CLFEXP canvas_widget_t * obj_to_canvas_widget( object_t *widget);
CLFEXP cairo_t * obj_to_cairo_t( object_t * object );
#endif

CLFEXP widget_t * obj_to_widget( object_t *widget);
CLFEXP char * obj_to_widget_text(int which, void * object );


//defunct
CLFEXP void font_into_obj( object_t *widget, char *face, int size, int weight, int slant, int decoration);

CLFEXP bounds_t  boundpt_to_bound(bounds_t *b);

CLFEXP int  radio_get_checked(object_t *object);
CLFEXP void  radio_set_checked(object_t *object, int check); 
CLFEXP object_t *group_selected(object_t *object); 

CLFEXP int structsize(char *cltype);

CLFEXP FILE *stdFILE(int c);


/*\@}*/
#endif
