/*r07118p6:41 for Euphoria strusts testing 
write/read file to detemine any padding in various compiler & setting
declare a few global and static vars to test c_var access
workout some automatic wrapping verification


*/

#ifndef _STRUCTSDLL_H
#define _STRUCTSDLL_H
/** \defgroup _STRUCTSDLL_
 * \brief The _STRUCTSDLL_
 * @{
 */

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include <math.h>
#include <float.h>
#include <stdint.h>

#include <signal.h>
#include <time.h>
#include <errno.h>
#include <setjmp.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>

//~ #ifndef FALSE

//~ #ifndef Bool
//~ typedef enum {
  //~ FALSE = 0, TRUE = 1
//~ } Bool;

//~ #else /* Bool */
//~ #define FALSE	0
//~ #define TRUE	1
//~ #endif /* Bool */
//~ #endif

#if !defined(__GNUC__) && !defined(__attribute__)
#define __attribute__(x)
#endif

/* for windows */
#ifndef SIGQUIT
#define SIGQUIT SIGABRT
#endif

#ifndef SIGUSR1
#define SIGUSR1 SIGABRT
#endif

#ifdef _WIN32
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT
#endif
//CLVEXP object_t *claro;
//CLFEXP   from claro to export
#ifdef _WIN32
#	ifdef PLUGIN
#		define CLFEXP __declspec (dllimport)
#	else
#		define CLFEXP __declspec (dllexport)
#	endif
#	define CLVEXP extern CLFEXP
#else
#	define CLFEXP
#	define CLVEXP extern
#endif

/* Define to 1 if you have the `uint8_t' function. */
//~ #undef HAVE_UINT8_T

/* Define to 1 if you have the `uint16_t' function. */
//~ #undef HAVE_UINT16_T

/* Define to 1 if you have the `uint32_t' function. */
//~ #undef HAVE_UINT32_T

/* Define to 1 if you have the `uint64_t' function. */
//~ #undef HAVE_UINT64_T

/* Define to 1 if you have the `uintptr_t' function. */
//~ #undef HAVE_UINTPTR_T

 

#ifdef _WIN32
typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int  uint32_t;
//~ typedef unsigned long long  uint64_t;
#else
typedef u_int8_t uint8_t;
typedef u_int16_t uint16_t;
typedef u_int32_t uint32_t;
typedef u_int64_t uint64_t;
#endif


typedef struct structsdll_t{
 int v;
 char name[32];
} structsdll_t;

/**
 * \brief to_ the  structsdll object
 * 
 * \param widget A valid object.
 */
CLFEXP structsdll_t * to_structsdll( structsdll_t *widget);

DLLEXPORT int structsizeof(void * t);

DLLEXPORT void creat_file (char *name);
DLLEXPORT void look_at_file (char *name);
DLLEXPORT void usage (int ret);
DLLEXPORT char *my_strdup(const char *str);
DLLEXPORT long long my_llabs(long long n);

DLLEXPORT int expect_char_sum(char (*f)(char, char));
DLLEXPORT int expect_unsigned_char_sum(unsigned char (*f)(unsigned char, unsigned char));


/*\@}*/
#endif
