--m0711p1:26 knownglobs.e things every program uses, need a better name
--ifdef around message_box and any other winisms


global constant knownglobals_version =  "0.1.0" --u0717p3:26

--these really should be builtin although YES,NO,MAYBE is another good use
global constant 
    TRUE = not 0      ,FALSE = not TRUE
    ,YES = TRUE       , NO = FALSE     ,MAYBE = -888888
    ,ON   = TRUE ,OFF   = FALSE

global object retval    --use to dump return values not wanted

include dll.e
include get.e
include msgbox.e
include misc.e
--include machine.e

--w32lib std/util/math
global function iff( atom test, object ifTrue, object ifFalse )
    -- returns ifTrue if flag is true, else returns ifFalse
    -- ex:  ? w32iff( 1, "this", "that" )
    --      --> "this"
    if test then
        return ifTrue
    else
        return ifFalse
    end if

end function

--std/util/math mod is_even is_odd or_all seqmax seqmin
global function is_odd(object x)
  return and_bits(1,x)
end function

global function is_even(object x)
  return not and_bits(1,x)
end function

global function seqmin(sequence s)
 atom m
  m = 1
  for i = 1 to length(s) do
    if s[m] > s[i] then m = i end if
  end for
  return m
end function

global function seqmax(sequence s)
 atom m
  m = 1
  for i = 1 to length(s) do
    if s[m] < s[i] then m = i end if
  end for
  return m
end function

global function seqmaxlen(sequence s, integer n)
 atom m
  m = 1
  for i = 1 to length(s) do
    if not atom(s[i][n])  and  m < length(s[i][n]) then m = length(s[i][n]) end if
  end for
  return m
end function

global function mod(object x1, object x2)
  return remainder(x1,x2)
end function
global function std_or_all(sequence s)
 -- syntax: a = or_all( s )
 -- description:
 --    combine a sequence of atoms using or_bits(), and return the value
 atom a
   a = s[1]
   for i = 2 to length(s) do
      a = or_bits(a,s[i])
   end for
   return a
end function


-- Routine: map from seqops.e, would include whole but have some conflicts
-- Syntax:  x = map(x, rid)  is backward, so changing to be more functional language type
-- Description: Applies the function pointed to by rid to every element of x unless x is an atom in which case it returns the function called with x. For this reason all functions that rid points to should ideally take objects. 
global function map( atom rid, object x)
sequence z z = {}
if atom(x) then
	return call_func(rid, {x})
else
	for i = 1 to length(x) do
		z &= call_func(rid, {x[i]})
	end for
return z
end if
end function 


--Created: 25. marec 2000 22:55, sobota
--Purpose: Converting One type to Another
--string to number
global function atoi(sequence NbStr)
-- convert a decimal string to it's integer value
integer i
    i = 0
    for n = 1 to length(NbStr) do
	if NbStr[n] >= '0' and NbStr[n] <= '9' then
	    i = i * 10 + NbStr[n] - '0'
	else
	    exit
	end if
    end for
    return i
end function -- AToI()


--empirelib std/util/sequence.e, 
--mod to return strings.  but may have to goto split 
--its ok, even if they don't print like strings they compare fine
global function explode(sequence s, object m)
 sequence ret, rets
 integer f
  ret = {}
  if not sequence(m) then m = {m} end if
  f = match(m,s)
  while f do
    ret &={ s[1..f-1] }
    s = s[f+length(m)..length(s)]
    f = match(m,s)
  end while
  if length(s) then ret &={ s } end if
  rets = {}
  for x=1 to length(ret) do
      rets &= {""&ret[x]}
   end for
  return  rets --want string returns
end function

global function implode(sequence s1, object m)
  sequence s2
  integer l
   l = length(s1)
   s2 = {}
   if l then 
     for i = 1 to l-1 do
       s2 &= s1[i] & m
     end for
     s2 &= s1[l]
   end if
   return s2
end function


--empirelib binary.e
global function bitshiftl(atom x, atom y)
  return x * power(2,y)
end function

global function bitshiftr(atom x, atom y)
  return floor( x / power(2,y) )
end function


--  abs ceil fraction round truncate math.e Author: J. Peterson
global function abs(object a)
-- Routine: abs
-- Syntax:  a = abs(x) 
-- Description: Returns the absolute value of the number. 
    object t
    if atom(a) then
	if a >= 0 then
	    return a
	else
	    return - a
	end if
    end if
    for i = 1 to length(a) do
	t = a[i]
	if atom(t) then
	    if t < 0 then
		a[i] = - t
	    end if
	else
	    a[i] = abs(t)
	end if
    end for
    return a
end function

global function ceil(object a)
-- Routine: ceil
-- Syntax:  a = ceil(x) 
-- Description: Rounds number towards positive infinity (opposite of Euphoria's floor()).  
    object t
    if atom(a) then
        return -floor(-a)
    else
        for i = 1 to length(a) do
            t = a[i]
	    if atom(t) then
                a[i]=-floor(-t)
	    else
	        a[i]=ceil(t)
            end if
        end for
    end if
    return a
end function


global function fraction(object a)
-- Routine: fraction
-- Syntax:  a = fraction(x), ... 
-- Description: Returns the fraction part of the number (e.g. fraction(3.14) returns 0.14). 
    object t
    if integer(a) then
	return 0
    elsif atom(a) then
	if a > 0 then
	    return a - floor(a)
	else
	    return a - 1 - floor(a)
	end if
    end if
    for i = 1 to length(a) do
	t = a[i]
	if integer(t) then
	    a[i] = 0
	elsif atom(t) then
	    if t > 0 then
		a[i] = t - floor(t)
	    else
		a[i] = t - 1 - floor(t)
	    end if
	else
	    a[i] = fraction(t)
	end if
    end for
    return a
end function

global function round (atom a)
-- Routine: round
-- Syntax:  a = round(x) 
-- Description: Rounds number towards nearest whole number. 
atom a_floor
    if floor (a) = a then  
	return a
    else                    
	    a_floor = floor (a)
	    if abs (a - a_floor) < 0.5 then 
	    return a_floor
	    else                           
	    return ceil (a)
	    end if
    end if
end function

global function truncate(atom x)
-- Routine: truncate
-- Syntax:  a = truncate(x), ... 
-- Description: Returns the non-fraction part of the number (e.g. truncate(3.14) returns 3).  
	return (x - fraction(x))
end function

--with trace out

global function seqsprintf(sequence format, object args) --not fully tested
    --make a sprintf that works on sequences
    --%r would be for sequence, otherwise its sprintf
    --would be much cooler if could append a format spec & callback to sprintf
   --running tests, but can see allot of holes in the recursion and cnt getting out of synch
   --not veriffying indexing 2..$, is there a 2?
    --handle %x and %02x and %X as lower upper, do %p pointer as hex %b binary
   --damm, just found  sprint(object x) -numerics all wrong
   --

   sequence s
    integer cnt
   sequence seq  
   sequence fs  

    cnt = 1
    seq = ""
    --have to replace %% with %` or something else otherwise will get empty seq
   
    format = explode(format, '%')  --getting too many empty sequences
    if not sequence(args) then args= {args}  end if
    --verify the number of args match number of formats, %% special case?
    --actually a zip(format,args) with a null args[x] when %% would be useful
   --trace(3) 1 2 3

    for x=1 to length(format) do
      s = format[x]
        --?s
      --peal off any numeric args, +- and push those
     
      --if not length(s) then s= {s}  end if
      if sequence(s) and length(s) then 
        if s[1] = 'r' then
               ? {cnt,args[cnt]}
            seq &= "{"
            for y=1 to length(args[cnt]) do
               --replace xyz=args[cnt][y]
               -- yxz=length(args[cnt][y]) >= 2  then  yxz=length(args[cnt][y]) end if
                if sequence(args[cnt][y]) then 
                 seq &= s[2..$]&seqsprintf("%r", args[cnt])
               elsif atom(args[cnt][y]) then
                  if integer(args[cnt][y]) then
                    fs = "%d"  --and x >= 32 and x <= 127 
                  else fs = "%f" --much room to move here
                  end if
                seq &= sprintf(fs&s[2..$], args[cnt])
                end if
            seq &= ","
            end for
          seq &= "}"
           cnt +=1
        elsif s[1] = '%' then
        elsif s[1] = 'p' then
            seq &= sprintf("#%x"&s[2..$], args[cnt])
            cnt +=1
        else  --g,f
            seq &= sprintf("%"&s[1..$], args[cnt])
            cnt +=1
        end if
    else  --if nothing was done then &= s
       if length(s) then 
         seq &= s
       else
        --~ ?{s, "@%"}
         --~ seq &= "%"
       end if
    end if
     
    end for
    -- ,}
  return seq
end function

--without trace 





global function dualdefault(integer h, integer w, integer maxlen)
 --for building tables of rows and colums, height,width  y,x in this case
 --idea is if you try to default one of them as -1 or 0, 
  --then they both get forced, a little specific to cgrep so far
 --need to send the maxlen r or c that would work, only caller knows.
 --needs a few seperate tests, not sure this is really bulletproof
  --tough cases are 2,5,15  do you go for 3,5 or 2,8? 
  --try to prefer more cols? or even?
 sequence tmp, default
 integer r,c

 --try to guess which direction is most important being 0 for fill in the blank
 --need actually ceil(maxlen/r) and maxlen has to be sane as well
 --this worked, but it prefered a zero to pick, really want >0 to pick
  --  default = iff(w != 0 and maxlen=h*w, {h, w} 
  -- ,iff(h != 0 and maxlen=h*w, {h, w} , {1, maxlen})
  --- )
  --default will only be used if r*c doesn't make sense
  default = iff(h >= 0 , {h, floor((maxlen/(h+.0001))+.6)} 
   ,iff(w != 0, {floor((maxlen/(w+.0001))+.6), w} ,{1, maxlen} )
   )

 if 0 then
  tmp= iff(w >0,{h, w}, default)
  r = tmp[1] c = tmp[2]

 --doesn't the iff suffer from something like 
 --if one term is never true or whatever that is never false can never be the isfalse
 --is a well known gotcha in python before ternary
 tmp= iff(r >0 and c >0, {r,c}, default)
  r = tmp[1] c = tmp[2]
 --make sure one or the other make sence
 --r = floor(maxlen/c) or floor(r/maxlen) 
 tmp= iff(maxlen=r*c, {r,c}, default)
 return tmp
 end if
 
  return default  --maybe this is good enough?

end function

global function isin(object star, sequence space)
   -- isin("1", "123") -> TRUE isin("0", "123") -> FALSE
   -- not quite ready to say for all s in all spaces, assume char in string for now
   -- how can I force s to be len one if it might be a char already?
    -- length errors on atom, sequence is a type check not a conversion function.
    -- return match(space,star) may not be empty sequence, could make it work?
   --this was an early incarnation of isin which find does better returns better info
   --find handles "" in either star or space corectly, 1 isin {2,1,3} ok too
   --checking =true/false could be a problem if isin should still be ok

    if not atom(star) and length(star) = 1 then star=star[1] end if --"1"->49
    --if atom(s) = 0 then return FALSE
    --if length(spaces) = 0 and atom(s) then return 0

    --why is this not short circuiting when space is 3?

    -- if atom(space) then return star=space end if
    -- if atom(star) then star= ""&star end if
    --if not length(space) then return 0 end if

    -- if not atom(star)  and  not length(star) then return FALSE end if

    -- everin = FALSE
    -- if atom(star) then  s = star 
    -- else    s = star[1] 
    -- end if
   -- --trace(1)

    -- for i=1 to length(space) do
        -- --need a while to loop on every inner sequence to be more general isin
        -- --if compare(s[1], spaces[i]) = 0 then
        -- if s = space[i] then
           -- everin = TRUE
        -- end if
    -- end for
 -- return everin  

  --would find work better? verify not nul is seq first
  return find(star, space) 
end function 

global function wraparound(integer inext, integer ilen)
  -- good for mode buttons, when next gets to len, wraparound base1
    if inext >= ilen then
        return 1
    end if
    return inext +1
end function


global function rjustlen(sequence strin, integer len)
  --in "1.2", 12   out "         1.2"  for fracchart
--should it expand tabs?
 sequence strout
 integer lenstrin

 lenstrin = length(strin)
 strout = ""

      --should check len-lenstrin makes sense
  for i=1 to len-lenstrin  do strout &= " " end for

  return strout & strin
end function

global function wrap_len(sequence strin, integer len, integer word)
 --your basic word wrap for more than one line in cmessage
  --attempt to return a sequence of lines spit at len
 --recursive, is probably not too speedy with great gobs of text.
 --attempt to split at a word boundry but no promisses
 --is a solved problem in chunks, except for splitting on word boundry
 --in spite of this having been written a few hundred thousand times already
--decided to roll my own, not even using code I have already written myself before.
 --just got to reinvent the wheel even though I know better than to try.
 --armed with some limited testing this time. 
  --though it passes for me it may not work in your application,
 --so add some tests, and please send any improvements or suggestions.
 --added a more complicateed start at 0 when wrapping then minus then +
 --still passed all the tests the same way. oh well
 integer wl, lenstrin 

  if len<1 or len >= length(strin) then return {strin} end if
  
  if word then 
   lenstrin  = length(strin)
    wl =  0
   --check backward first then forard from 0
   while 1 do
              --probbly other punct could split on, try not to split URL's? lost cause
              --to get this right would take thousands of lines of exceptions
     if len+wl < lenstrin and isin(strin[len+wl], "  :;,\"'+=-\n") then
       exit
     end if

     --test variable access faster than recomputing for the 3 times it will happen     
     if wl <= 0 then  --1  guess ++1 is out too
        if wl >  floor(len* -0.15)  then
        wl -= 1
       else
         wl = 1
         end if
      else
         if wl <  floor(len* 0.08)  then
            wl += 1
          else
            wl = 0
            exit
          end if
      end if
    end while
  else
    wl = 0
   end if

  return  {strin[1..len+wl]} &wrap_len(strin[len+1+wl..$],  len,  word) 
end function
 
---empirelib force a fatal error and display the given msg
-- use this to force a debug dump to ex.err
global procedure fatal_error(sequence msg)
  -- crash_message("Fatal Error: "&msg&"\n")--LF clears screen, very unfriendly to debuging
  puts(1,"\n"&msg)
   ? 1/0
end procedure

 -- chessclk.ex
global procedure pause(atom delay)
-- Gives control to calling module only after specified delay has elapsed
    atom t
    t = time()
    while time() < t+delay do
	-- just laze around for a millisecond or two... sleep(delay)?
    end while
end procedure


--<<  Derek Parnell Re: makedoc, change all message_box to show_msg
 --Displays a message on the screen and waits for acknowledgement.
-- It returns the Key (integer) used as the response.
-- The Style parameter can be one of ...
--   0  ==> Press ENTER key to continue
--   1  ==> [ Okay ] or [ Cancel ]
--   2  ==> [ Abort ], [ Retry ] or [ Ignore ]
--   3  ==> [ Yes ], [ No ] or [ Cancel ]
--   4  ==> [ Yes ] or [ No ]
--   5  ==> [ Retry ] or [ Cancel ]
--   { KEYLIST, KEYMSG} where KEYLIST is a sequence containing acceptable
--        key that will return control to the application, and KEYMSG is
--        a message showing the user what the options are.
--
-- Regardless of which style is used, the ENTER and ESCAPE keys will always
-- return control as well. The ENTER key signifies the default option and
-- the ESCAPE key represents the 'cancel' option. These are application
-- defined.
--
-- ** Examples:
--  res = show_msg("File has been updated.", "MYAPP", 0)
--
--  res = show_msg("Which fruit is required?", "MYAPP",
--                {"oOaAbB", "Orange, Apple or Banana"})
--
--should also define MB_OK etc or equilivents, also missing Beep and combining styles
-->>

function show_msg(sequence pMsg, sequence pTitle, object pStyle)
    integer lKey
    sequence lKeys
    sequence lCont
    sequence lBorder
 
 
 
    lKeys = "\r\n" & 27
    lCont = "Press ENTER key to continue..."
 
    if atom(pStyle) then
        if pStyle = 1 then
            lKeys = "oOcC" & lKeys
            lCont = "[ Okay ] or [ Cancel ]?"
        elsif pStyle = 2 then
            lKeys = "aAiIrR" & lKeys
            lCont = "[ Abort ], [ Retry ] or [ Ignore ]?"
        elsif pStyle = 3 then
            lKeys = "yYnNcC" & lKeys
            lCont = "[ Yes ], [ No ] or [ Cancel ]?"
        elsif pStyle = 4 then
            lKeys = "yYnN" & lKeys
            lCont = "[ Yes ] or [ No ]?"
        elsif pStyle = 5 then
            lKeys = "rRcC" & lKeys
            lCont = "[ Retry ] or [ Cancel ]?"
        end if
    elsif length(pStyle) = 2 and 
          sequence(pStyle[1]) and 
          sequence(pStyle[2]) then
        lKeys = pStyle[1] & lKeys
        lCont = pStyle[2]
    end if
    lBorder = repeat('*', length(pTitle) + 8)
 
    printf(1, "\n  %s\n   %s\n  ", {lBorder, pTitle})
    printf(1, "%s", {pMsg})
    printf(1, "\n    %s", {lCont})
 
    lKey = get_key()
    while find(lKey, lKeys) = 0 do
        lKey = get_key()
    end while
 
    return lKey
end function
 
 

--rc-demo
global procedure not_found(sequence msg)
    puts(1, "sleep9, not found or error " & msg & '\n')
   sleep(9)
    abort(1)
end procedure

--work these up to be more general use, right now they expect multi dimension
--first dimension ignore, is a widgetlist
global function getkeyobject(sequence wid, object keystring, integer n)
    --poor mans assositive array
    --something that will go from a string 
    --to a matching string in a subsequence of n
    --up to you to make sure the sequence & key make sense
    --may -1 for error, so don't just if key or especially if not key
    --really shouldn't matter if keystring is a string or something else
    --no doubt I shouldn't be rolling my own here either
    --add some unittests, assumes all sequences are egual length
  --typical array has [1] {widgets, whatever, constants} then gets interesting
  -- if you put anything into 1 it won't get found
   --undefined but maybe repetable results if keystring is a string and wid[x][n] isn't

   --~ if atom(wid) or length(wid)  <2 then return -1 end if
   if length(wid)  <2 then return -1 end if
   if n > length(wid[2]) or n < 1 then return -1 end if
    for x= 2 to length(wid) do
      if sequence(wid[x]) then 
        if sequence(wid[x][n]) then
          if compare(wid[x][n], keystring) = 0 then -- -1 0 1
            return x
          end if
        --assume its comparable directly, in one case needs explode
        elsif wid[x][n] = keystring then
            return x
        end if
      end if
    
    end for
  return 0  --not found
end function

global function getkey(sequence wid, atom key, integer n)
    --poor mans hash table, specific to widget*lists widgetcreate actually
    --find key in n dimension, assumes key is number,
     -- better to use find for one dimension
    --up to you to make sure the sequence & key are unique
    --may -1 for error, so don't just if key or especially if not key
    --if atom(wid) then return -1 end if  won't pass typecheck anyway
    --but could help if typecheck off?
   if atom(wid) or length(wid)  <2 then return -1 end if
    if n > length(wid[2]) or n < 1 then return -1 end if
    for x= 2 to length(wid) do
        if wid[x][n] = key then
            return x
        end if
    end for
  return 0
end function


global function getkeystring(sequence wid, integer key)
    --poor mans safe index, specific to widget*lists
    --basically check indexes and try to return something
    --although when you need it, you probably have a bad key anyway
    if key >0 and key <= length(wid) then
        return wid[key]
    end if
  return "not found"
end function



 --maybe I should put this in my own struct associative array packge?
 --this would be built dynamically if it's found that libs vary on size of items
 --maybe the stdlibs have this info somewhere already?
 --similar for any dll interface structure wrapping job
 --put the Euphoria C_type in [1], what ever else is ignored by isize of or key*()
  --a base2 language construct like the other key* functions, 1st seq is ignored
 -- might encode size but would have to redo all the C_types #hibyte+#4
 -- so size would be lobyte(C_Type) reducing the need for a table at all
 --but then would need a table at the function call to get the rds C_type again
sequence istruc  
istruc = { {}  
 ,{C_CHAR, 1}  -- not 1 for unicode
 ,{C_UCHAR, 1}  --
 ,{C_SHORT, 2}  --tricky
 ,{C_USHORT, 2}  --
 ,{C_INT, 4}  --
 ,{C_UINT, 4}  --
 ,{C_LONG, 4}  --C_INT
 ,{C_ULONG, 4}  --C_UINT,
 ,{C_POINTER, 4} -- C_ULONG
 ,{C_FLOAT, 4}  --?
 ,{C_DOUBLE, 8}  --?16??  what about longdouble quaddouble
	 --~ E_INTEGER = #06000004,
	 --~ E_ATOM    = #07000004,
	 --~ E_SEQUENCE= #08000004,
	 --~ E_OBJECT  = #09000004
}

global function isizeof(sequence st, integer ikey)
 --istruc is a type to size table, C_POINTER is how big on which system
 -- everyone is saying its always 4 bytes, but does the dll know that?
 --ikey is the position of the C_TYPE info in the passed seq
 --ikey+1 is how many of them, assume nothing about packing or alignment
  --nor about endian, this is a temp exploratory implementation. not definitive!
 integer key
 integer i i = 0

 for x=2 to length(st) do
   if sequence (st[x][ikey]) then i += isizeof(st[x][ikey], ikey)
   else 
    key = getkeyobject(istruc, st[x][ikey], 1)
    if key <= 0 then not_found(sprintf("bad key in structure from isizeof @%d",{x})) end if
    i += istruc[key][2] * st[x][ikey+1]
   end if
 end for
 return i
end function




global procedure dos32abort(sequence msg)
  if  (platform() = DOS32) then 
    printf(2, "\n\nneeds to open a library dll/so, sorry no DOS\n%s\n", {msg})
    msg = prompt_string("hit key")  -- prompt doesn't work in exw?
    -- for x=1 to 10000000 do end for  --have to be way higher number than a few thou
    abort(1)
  end if
end procedure


global procedure exitpause(sequence msg)
 --exw seems to exit the window because unittest is using abort?
 --exw doesn't by default create a console unless something is written, then it idssapears!
 --another way is to leave warnings and undefined vars
 --msg = msg or "to exit"
 --msg = msg & " hit key" 
 retval=IDNO
  if  (platform() = DOS32) then 
    msg = prompt_string(msg& " hit enter" )  -- prompt doesn't work in exw?
  elsif (platform() = WIN32) then
     msg = msg & "[YES] =  Force Error  [NO] = abort(0)" 
    retval = message_box(msg , "hey wait!",or_bits(MB_YESNO,or_bits(MB_ICONEXCLAMATION,MB_TASKMODAL)) ) 
  -- MB_SYSTEMMODAL
  else
    retval = show_msg(msg , "hey wait!", 0) 
  end if

   if retval=IDNO then -- 27  Esc by Don Cole
    abort(0)
   elsif retval=IDYES then  --315   F1
     ?9/0 
   end if

end procedure


global procedure crash_handler()
    --'try not to cause a loop or a crash here!
    retval = show_msg("woops, crashhandler shutting down", "hey waitup!", 0)
    
end procedure

--crash_file("NUL")
--crash_file("c:\\windows\\desktop\\ex.err")
-- should do a version check here crash only works in 2.5 or better?
-- crash_routine(routine_id("crashhandler"))

--r06C1a7:20 
--r06C7p7:30:21 added exitpause
--t06C19p2:16 crashhandler timeit
--t06C26p9:52 ffew from empirelibs is_odd/even mod iff from win3222lib too
--dualdefault for cgrep 
--s06C30a9:15 wraparound for the beginings of modebuttons in cdtef
--m0711p1:26 show_msg, little more cross platform, I still like the popup though
--u0717p2:05 add isizeof, continuing to map out the key* associative array thing
-- it should be possible to declare c structs and get and set them reliably 
-- not 100% sure about how packing and padding works, if is in file storage only.
--
-- each file needs its own version number now since it deals with info that can
-- affect (notice not effect!) how isize is used in past versions
-- but if I make version a global constant it will conflict and if local be useless
--maybe concatate the filename&version to get the constant name?
--should hardwire a date and md5 crc so can know its the real thing
--or wingit like the plugins do, or doo FREE-len file like some of the win API wraps do
--r07111p6:27  abs ceil fraction round truncate math.e
--s07113a11:36 trying to integrate some of empire std libs for structs for claro cairo wrap
-- had to do some creative renaming and paste in a few things to get the minimum required
--to get the includes to work, require cb1 exw presently or put everything in the same dir 
--and remove the dir/ part of the includes, there is no turning backward compatible now...
--m07115p04:31:01 [YES] =  Force Error  [NO] = abort
--w07117p8:39:47seqsprintf


--e
 