-- empire lib for  structs V2 converted to use rds libs for the claro cairo wrap project ---
-- this version is unreleased alpha copy and all errors introduced are probably mine --
--~u07408p12:41  --~ step_proc("puts",2,{1,{"line1\n","line2\n"}})
 --~ step_proc(routine_id("puts"),2,{1,{"line1\n","line2\n"}})
--~ invalid routine id
 --~ step_proc(puts,2,{1,{"line1\n","line2\n"}})
--~ Syntax error



--~ include std/core.em

global type sequence_slice(object s)
  if atom(s) then return 1 end if
  if length(s)=2 then
    if integer(s[1]) and integer(s[2]) then
      return 1
    end if
  end if
  return 0
end type

global function splice(sequence s, sequence_slice indices, object x)
  if atom(indices) then indices = {indices,indices} end if
  return s[1..indices[1]-1] & x & s[indices[2]+1..length(s)]
end function


--~ global function reverse(sequence s)
--~ -- reverse the top-level elements of a sequence.
--~ -- Thanks to Hawke' for helping to make this run faster.
 --~ integer low, n, n2
 --~ sequence t
 
   --~ n  = length(s)
   --~ n2 = floor(n/2)+1
   --~ t  = repeat(0, n)
   --~ low = 1
   --~ for high = n to n2 by -1 do
      --~ t[high] = s[low]
      --~ t[low] = s[high]
      --~ low += 1
   --~ end for
   --~ return t
--~ end function


--~ -- intialize a sequence, similar to repeat, except where dims is a sequence
--~ --  of dimension sizes, which will be nested
--~ -- Example:
--~ --    s = dim(0,{3,3}) -- produces a 3x3 dimensioned sequence
--~ --    -- s is now {{0,0,0},{0,0,0},{0,0,0},{0,0,0}}
--~ global function dim(object init, object dims)
  --~ if atom(dims) then dims = {dims} end if
  --~ if not length(dims) then return {} end if
  --~ if not integer_array(dims) then return {} end if
  --~ for i = length(dims) to 1 by -1 do
    --~ init = repeat(init,dims[i])
  --~ end for
  --~ return init
--~ end function


-- reduces a sequence of any dimension to a flat array
-- * NOTE* ALL elements will be flattened to a single array
--   meaning an array of strings becomes a single array of characters
global function flatten(object x)
 sequence ret
  if sequence(x) then
    ret = {}
    for i = 1 to length(x) do
      ret &= flatten(x[i])
    end for
    return ret
  end if
  return x
end function

-- walk the first dimension of a sequence, calling rID with args for each element
-- the sequence that will be iterated is args[step_arg]
-- EXAMPLE:
--   step_proc("puts",2,{1,{"line1\n","line2\n"...}})
global procedure step_proc(integer rID, integer step_arg, sequence args)
 sequence list
  list = args[step_arg]
  for i = 1 to length(list) do
    args[step_arg] = list[i]
    call_proc(rID,args)
  end for
end procedure

-- returns a sequence of the same length as the iterated list, containing the values returned from each callback
global function step_func(integer rID, integer step_arg, sequence args)
 sequence list
  list = args[step_arg]
  for i = 1 to length(list) do
    args[step_arg] = list[i]
    list[i] = call_func(rID,args)
  end for
  return list
end function


type sequence_slice_array(object x)
  if sequence(x) then
    for i = 1 to length(x) do
      if not sequence_slice(x[i]) then return 0 end if
    end for
    return 1
  end if
  return 0
end type

-- global function split(sequence s, sequence_slice_array slice)
--  sequence ret
--  integer start,stop,x
--   if length(slice) then
--     start = 1
--     stop = 0
--     for i = 1 to length(slice) do
--       if atom(slice[i]) then slice[i] = {slice[i],slice[i]} end if
--     end for
--     slice = flatten(slice) -- reduce to 1 dimension
--     if slice[length(slice)] != length(s) then slice &= {slice[length(slice)]+1,length(s)} end if

--     ret = {}
--     start = 0
--     stop = 0
--     x = 1
--     while x <= length(slice) do
--       if slice[x] = stop+1 then
--         start = slice[x]
--         stop = slice[x+1]
--         x+=2
--       else -- a gap needs to be parsed
--         start = stop+1
--         stop = slice[x]-1
--       end if
--       ret &={ s[start..stop] }
--     end while
--     return ret
--   else -- nothing to do, just return the sequence
--     return s
--   end if
-- end function

global function replace(sequence s,object x1,object x2)
  for i = 1 to length(s) do
    if equal(s[i],x1) then s[i] = x2 end if
  end for
  return s
end function

global function replace_all(sequence s,sequence x1, sequence x2)
 integer f
  if length(x1) != length(x2) then return s end if
  for i = 1 to length(s) do
    f = find(s[i],x1)
    if f then s[i] = x2[f] end if
  end for
  return s
end function

global function replace_match(sequence s, object x1, object x2)
 sequence r
 integer f
  if atom(x1) then x1 ={ x1 } end if
  if atom(x2) then x2 ={ x2 } end if
  r = ""
  f = match(x1,s)
  while f do
    r &= s[1..f-1]& x2
    s = s[f+length(x1)..length(s)]
    f = match(x1,s)
  end while
  if length(s) then r &= s end if
  return r
end function

--~ global function explode(sequence s, object m)
 --~ sequence ret
 --~ integer f
  --~ ret = {}
  --~ if not sequence(m) then m = {m} end if
  --~ f = match(m,s)
  --~ while f do
    --~ ret &={ s[1..f-1] }
    --~ s = s[f+length(m)..length(s)]
    --~ f = match(m,s)
  --~ end while
  --~ if length(s) then ret &={ s } end if
  --~ return ret
--~ end function

--~ global function implode(sequence s1, object m)
 --~ sequence s2
 --~ integer l
  --~ l = length(s1)
  --~ s2 = {}
  --~ if l then 
    --~ for i = 1 to l-1 do
      --~ s2 &= s1[i] & m
    --~ end for
    --~ s2 &= s1[l]
  --~ end if
  --~ return s2
--~ end function

global function merge(sequence s1)
 sequence s2
 integer c1,c2
  c2 = 0
  for i = 1 to length(s1) do
    c2 += length(s1[i])
  end for
  if not c2 then return {} end if
  s2 = repeat(0,c2)
  c1 = 0
  c2 = 0
  while c2 < length(s2) do
    c1 += 1
    for i = 1 to length(s1) do
      if c1 <= length(s1[i]) then
        c2 += 1
        s2[c2] = s1[i][c1]
      end if
    end for
  end while
  return s2
end function

global function subscript(sequence s, object index)
 object ret
  if atom(index) then index = {index} end if
  ret = s
  for i = 1 to length(index) do
    if atom(index[i]) then
      if index[i] < 1 then index[i] = length(ret)-index[i] end if
      ret = ret[index[i]]
    else
      if index[i][1] < 1 then index[i][1] = length(ret)-index[i][1] end if
      if index[i][2] < 1 then index[i][2] = length(ret)-index[i][2] end if
      ret = ret[index[i][1]..index[i][2]]
    end if
  end for
  return ret
end function
