--from unittest.e Unit testing framework Jeremy Cowgar Nov 18/06 rds archive
--
--t06C5p12:48 forget the abort on test failed, popup a window if an oiption was set to pause
--added startup and shutdown in my unittests but unittest should provide them
--better yet just return the report for the calling program to display if it wants to
--only a problem called from exw w/o console window open, 
--it dissapears before you can see the summary, 
--leave on with warning and unused var will keep window open
-- need to return the status so the popup can show it
-- prettyprint arrays needs to be an option to preserve vertical space on limited win9x console
-- if want to output failed + verbose arrays need to setTestVerbosity(TEST_FAILED_COMPACT)
-- or build from the bits, things just got a bit more complicated. sorry
--adding random object creator, not sure this will work well from unittest
-- maybe better to be part of a mock package
-- timeit would be a good option, maybe a timetestEqual() or something
--need to wrap function in routine_id though 
--could test procedures too? if supply some external variable that changes
--I guess you could wrap that yourself though
--u07325p3:40 /0 error if no test run
-- seems to be under counting tests run in clarowrap.et
--t07417a11:41 added side by side string/decimal sequence at "but got:"
--limit the size of the sequence to half. could check if over 4 then start limiting


--one of the reporting types should be output all tests to file or stdout +verbose

include misc.e

--
-- Public Variables
--

global constant 
    TEST_QUIET = 0
    ,TEST_SHOW_FAILED_ONLY = 1
    ,TEST_SHOW_ALL = 2          --#00000010
    ,TEST_VERBOSE_ARRAYS  = 32 --#00100000
    ,TEST_FAILED_COMPACT = or_bits(TEST_SHOW_FAILED_ONLY, #00 )
    ,TEST_FAILED_VERBOSE = or_bits(TEST_SHOW_FAILED_ONLY, TEST_VERBOSE_ARRAYS )
    
global atom testCount, testsPassed, testsFailed

testCount   = 0
testsPassed = 0
testsFailed = 0

--
-- Private variables
--

atom verbose, verbose_arrays
verbose = 0
verbose_arrays = 0

sequence currentMod, temp
currentMod = ""

--
-- Private utility functions
--


procedure testFailed(sequence name, object a, object b)
        if verbose > 0 then
                printf(2, "  failed: %s. expected: ", {name})
                if verbose_arrays > 0 then 
                    pretty_print(2, a, {2})
                else
                    if sequence(a) and length(a) then  --strings still numeric
                        for sx=1 to length(a) do
                            puts(2,  sprint( a[sx]))
                        end for
                    else
                        puts(2,  sprint( a)) --numerics all wrong
                       --printf(2, " %s ", {a})  --printf & puts outputs numerics all wrong
                       --going to have to add an option here for no excess \n\t
                       --pretty_print(2, a, {2,0,88})
                    end if
                end if
                puts(2, " but got: ")
                if verbose_arrays > 0 then 
                    pretty_print(2, b, {2})
                else
                    if sequence(b) and length(b) then
                        for sx=1 to length(b)/2+1 do
                            temp = {} puts(2, "{")  
                            if sequence(b[sx]) and length(b[sx]) then
                              for sxx=1 to length(b[sx]) do
                                    puts(2,  sprintf("%s", {b[sx][sxx]
                                                ,iff(b[sx][sxx]<128 and b[sx][sxx]>31,b[sx][sxx],"`")}))
                                   temp &= b[sx][sxx]
                              end for
                             else
                               temp &= b[sx]
                            end if
                            puts(2, sprint(temp)) puts(2, "}")
                        end for
                    else
                        puts(2,  sprint( b))
                        --printf(2, " %s ", {b})
                        --pretty_print(2, b, {2,0,88})
                    end if
                end if
                puts(2, "\n")
        end if
        
        testsFailed += 1
end procedure

procedure testPassed(sequence name)
        if verbose > 1 then
                printf(2, "  passed: %s\n", {name})
        end if
        
        testsPassed += 1
end procedure

--
-- Global Testing Functions
--

--seed random so it can be repeated, assuming the same calling sequences
set_rand(20) 
constant mtemp =  {"string",  "sequence", "integer", "atom"}  --,  "any"
global function  rgo( --randomgeneratedobject
     object template, integer arrays, integer items)
   --generate a random array of length arrays, each of item length
   -- template might be {"string", "integer", "any" .. items}
  -- length and items can be random selected as well as their contents
 --assuming this can work, and you can decide what is a passing test
 ---throwing lots of random arrays at a function could showup errors
 --too tedious to find by thinking up all the corner cases
 --no gaurentee that if the random array test passes there are no bugs of course.
 sequence gen
 object a 
   if items <=0 then items = rand(20) end if
   if arrays <=0 then arrays = rand(20) end if

   if atom(template) and template<=0 
        or sequence(template) and  not length(template) then 
     template = {}
     for i=1 to items do
        a = rand(4) 
        template &= mtemp[a]
      end for
   end if

  gen = {{}}
  for i = 1 to arrays do
    gen &= {}  --is not adding a blank sequence?
      --? {"gen="}&gen  --not printing as string again for some reason
      
    --turn this into a function so can call with rand(4) for any
    for j = 1 to length(template) do
        if compare(template[j], "string") then
            a = "something"
        elsif compare(template[j], "sequence") then
            a = {32,33,34,35}
        elsif compare(template[j], "atom") then
            a = 22.3
        elsif compare(template[j], "any") then
            a = "any" 
        else 
            a = rand(160)-32 --keep it aschii
        end if
        --gen[i] &= type()
        gen[$] &= {a}
    end for
   end for
 return gen
end function


global function timeit(object f, atom ftime)
-- appologies to Connelly Barnes Jun 2004 and uncle timmy, 
  -- Calls f many times to determine
   -- the average time to execute f.
  -- Usually accurate to within 3%

  --add to unittest maybe as a patch if it works out cross platform?
  --somewhat different passing functions around in python vrs euphoria at runtime
  --need a way to know if f is a function or procedure

   atom st, sp, T, count
   if ftime =0 then  ftime = 0.5 end if
  count = 2
   while TRUE do
    st = time()
    for i=1  to count do  call_proc(f, {}) --call_func
    end for
    sp = time()
    T = sp - st
     if T >= ftime then  exit end if
    count *= 2
   end while
  return T / count

-- from math import *
-- def f(x): return x * x - cos(x)
-- def g(): return f(1.0)

-- t = timeit(routine_id("g"), 2)
-- print 'Time to execute f: ', t
-- print 'Calls to f per second: ', 1.0/t

end function


global procedure setTestVerbosity(atom verbosity)
    --extract TEST_VERTICAL_ARRAYS  unittest needs unittests
    --not sure about this, need to test 2 as well to see if all is set
    verbose = and_bits(verbosity, 7)
    verbose_arrays = and_bits(verbosity, 32)
   printf(2, "test verbosity=%d  verbosity_arrays=%d  ",{verbose, verbose_arrays})
end procedure

global procedure setTestModuleName(sequence name)
        currentMod = name
        
        printf(2, "%s:\n", {currentMod})
end procedure

global procedure testSummary()
        if verbose > 0 then
                puts(2, "\n")
        
                printf(2, "%d tests run, %d passed, %d failed, %d%% success", 
                        {testCount, testsPassed, testsFailed, (testsPassed / testCount) * 100})
        end if
        
        --abort(testsFailed > 0)  
end procedure

global procedure testEqual(sequence name, object a, object b)
        testCount += 1
        
        if equal(a, b) = 0 then
                testFailed(name, a, b)
        else
                testPassed(name)
        end if
end procedure

global procedure testNotEqual(sequence name, object a, object b)
        testCount += 1
        
        if equal(a,b) then
                testFailed(name, a, b)
        else
                testPassed(name)
        end if
end procedure

--
