#!python
#w07228p5:49:49 gcc -E  -o ./target.o output is preprocessed claro headers, include cairo later
#downside some of the macros are expanded, have to let it intersperce real code + comments?
#upside, macros are expanded. I expected to see allot more stdlib excess duplication etc.

import os, glob

env = Environment(ENV=os.environ)
target3 = "cmain-include"  

RELEASE =False #True

#need to change obviously for bcc or vc
env['CC'] = 'gcc' #think it defauilts to g++ mangling the structsdll exports



#CFLAGS ignored,  CCFLAGS for c, CXXFLAGS for c++
if RELEASE: #RELEASE -O2 -mmmx  -march=i686
    env['CCFLAGS'] = Split(r''' -E   -Os -W -Wall -Wno-uninitialized
     -IF:\c\MinGW\include\cairo
     -IE:\c\c\make_all\Tool\gui\claro\claro\src
     ''')  #-v #strip
    env['LINKFLAGS'] = Split(r'''-s -mwindows  
     -LE:\c\c\make_all\Tool\gui\claro\claro\build
     ''') 
else:
    # Os chg to -g and add include dir to src, remove -s -mwindows  strip
    env['CCFLAGS'] = Split(r'''' -E  -g -W -Wall -Wno-uninitialized
     -IF:\c\MinGW\include\cairo
     -IE:\c\c\make_all\Tool\gui\claro\claro\src
     ''')  #-v 
    env['LINKFLAGS'] = Split(r'''
     -LE:\c\c\make_all\Tool\gui\claro\claro\build
     ''') 



res = glob.glob('*.rc')
if res:
        env['RCFLAGS'] = Split('-O COFF') #'--include-dir=.',
        env.RES('%s.res'%target,  res)
        res = '%s.res'%target

if  RELEASE:
    #libs=Split('cairo-claro-graphics cairo-claro-base m cairo png')  #release
    libs=Split('claro-graphics claro-base m cairo png')  #release
else:
    # LIBS=Split('shell32  winmm') zlib1 gdi32
    #libs=Split('Dcairo-claro-graphics Dcairo-claro-base m cairo png') #debug
    libs=Split('claro-graphics claro-base m cairo png') #debug

env.Program("%s"%target3, ["%s.c"%target3,  ]+res, LIBPATH='.', LIBS=libs)


#e
