 /*testsuncomment.c
 * tests for ``uncomment''
 * assume C-code conventions:
 *      strings start and end on one line
 *      comments can be multi-line
 * no tests for varieties of:   '"'   \'"\'   etc
 * no tests for strings with newline escaped
 */
string4         "hi /*\"hi there*/there\""
comment1                /*one"*/"*/
comment2                /*\"hi there"*/"*/"
comment3                /*\"hi there*/
comment4                /* hello/*hello/*hello/*hello*/
comment5                /*******/
comment6                /*/*/ a /**/ b /***/ c /****/ d /*////*/
comment7                /*/*// a /**// b /***// c /****// d /*////*//

1. /*****//"hello world */"                           ok   /"hello world */"
2. /* hello /* /* world */                              ok      
3. /* */ hello /* */                                    ok      hello
4. /**// /* this should produce "/ \n" for output */  ok      /
5. /* */ hello */                                       ok      hello */
6. /*/*/ hello                                          ok      hello
7. /*////*/                                             ok      
8. /*//*/                                               ok      
9. abc = "/* fake comment"; /* got who ? */           ok      abc = "STRING";
10. /*   "start quote
        "then next line end quote, after more characters than on line 1"
        more more more */  "                               ok      "
