--w0737p1:40 part of empirelib  
-- http://www.creativeportal.ca                          written by Chris Bensler
--changed any_key to exitpause
--also requires parts of declare.e folded into wrap_extras and knownglobs for clarowrap. thanks!

--may have to modify to return its' output as string instead of printing to console for gui use

-- TEST CODE --
--~ include wrap_extras.ew --

--include std/standard.em
--include std-enum.e


without warning

sequence Command_Line     Command_Line = {"","","",{{},{},{}}}
constant
  DESCRIPTION = enum_start(1,1)
 ,SYNTAX      = enum()
 ,INFORMATION = enum()
 ,OPTIONS     = enum()

global constant cliFLAG=1 , cliPARAM=2 , cliDEFAULT=3
global constant
    CLI_REQUIRED = enum_start(EOF,-1)

global procedure cli_set_description(sequence s)
  Command_Line[DESCRIPTION] = s
end procedure

global procedure cli_set_syntax(sequence s)
  Command_Line[SYNTAX] = s
end procedure

global procedure cli_set_information(sequence s)
  Command_Line[INFORMATION] = s
end procedure

global procedure cli_set_option(sequence flag, object default, sequence info)
  Command_Line[OPTIONS][cliFLAG]  &={ flag }
  Command_Line[OPTIONS][cliDEFAULT]   &={ default }
  Command_Line[OPTIONS][cliPARAM] &={ info }
end procedure

global function cli_enum_option(sequence flag, object default, sequence info)
-- same as above but returns the option index
  cli_set_option(flag,default,info)
  return length(Command_Line[OPTIONS][cliFLAG])
end function

global procedure cli_show_help()
 sequence pos,tmp
 integer maxl
  puts(STDERR,Command_Line[DESCRIPTION]&CRLF)

  puts(STDERR,"Syntax : ")
  tmp = explode(Command_Line[SYNTAX],LF)
  if length(tmp) then
    tmp[1] &= LF
    for i = 2 to length(tmp) do tmp[i] = "         "&tmp[i]&LF end for
  end if
  puts(STDERR,flatten(tmp)&CRLF)

  maxl = 0
  for i = 1 to length(Command_Line[OPTIONS][cliFLAG]) do
    if length(Command_Line[OPTIONS][cliFLAG][i]) > maxl then
      maxl = length(Command_Line[OPTIONS][cliFLAG][i])
    end if
  end for
  maxl +=3
  for i = 1 to length(Command_Line[OPTIONS][cliFLAG]) do
    if length(Command_Line[OPTIONS][cliPARAM][i]) then
      puts(STDERR,"\r    "&Command_Line[OPTIONS][cliFLAG][i]&" ")
      tmp = explode(Command_Line[OPTIONS][cliPARAM][i],LF)
      if length(tmp) then
        tmp[1] &= LF
        for j = 2 to length(tmp) do
          tmp[j] = repeat(' ',maxl+4)&tmp[j]&LF
        end for
      else
        tmp = {LF}
      end if
      puts(STDERR,repeat(' ',maxl-length(Command_Line[OPTIONS][cliFLAG][i])-2))
      puts(STDERR," "&flatten(tmp))
    end if
  end for
  puts(STDERR,CRLF)
  if length(Command_Line[INFORMATION]) then
    puts(STDERR,CRLF&Command_Line[INFORMATION]&CRLF)
  end if
  exitpause("\n\nPress any key\n\n")  --any_key
  abort(0)
end procedure

global procedure cli_error(sequence msg)
  puts(STDERR,msg&CRLF&CRLF)
  cli_show_help()
end procedure

global function cli_get_options(integer help_flag)
 -- if help_flag is TRUE, then if no arguments are passed, the help will be displayed
 --  and the cli_error() routine will be set
 sequence cl,params
 integer n,nn,xtra
  cl = command_line()
  if not length(Command_Line[SYNTAX]) then
    cl[2] = explode(cl[2],SLASH)
    cl[2] = cl[2][length(cl[2])]
    xtra = FALSE
    n = 0
    while n < length(Command_Line[OPTIONS][cliFLAG]) do
      n += 1
      if xtra and not length(Command_Line[OPTIONS][cliPARAM][n]) then
        cl[2] &= " "&Command_Line[OPTIONS][cliFLAG][n]
      else
        if xtra then
          cl[2] &= "]"
          xtra = FALSE
        end if
        if equal(Command_Line[OPTIONS][cliDEFAULT][n], CLI_REQUIRED) then
          cl[2] &= " "&Command_Line[OPTIONS][cliFLAG][n]
        else
          cl[2] &= " ["&Command_Line[OPTIONS][cliFLAG][n]
          xtra = TRUE
        end if
      end if
    end while
    if xtra then cl[2] &= "]" end if
    Command_Line[SYNTAX] = cl[2]
  end if
  params = repeat(repeat(FALSE,length(Command_Line[OPTIONS][cliFLAG])),2)
  n = 0
  for i = 1 to length(Command_Line[OPTIONS][cliFLAG]) do
    if Command_Line[OPTIONS][cliFLAG][i][1] = '-' then
      params[cliFLAG][i] = Command_Line[OPTIONS][cliDEFAULT][i]
      if sequence(params[cliFLAG][i]) then
        params[cliPARAM][i] = params[cliFLAG][i]
        params[cliFLAG][i] = TRUE
      end if
    elsif not length(Command_Line[OPTIONS][cliPARAM][i]) then
      params[cliFLAG][i] = Command_Line[OPTIONS][cliDEFAULT][i]
      if sequence(params[cliFLAG][i]) then
        params[cliPARAM][i] = params[cliFLAG][i]
        params[cliFLAG][i] = TRUE
      end if
    else
      if not n then n = i end if
      params[cliFLAG][i] = Command_Line[OPTIONS][cliDEFAULT][i]
    end if
  end for
  nn = 0
  for i = 3 to length(cl) do
    if cl[i][1] = '-' then -- flag
      if nn and not length(Command_Line[OPTIONS][cliPARAM][i]) and atom(Command_Line[OPTIONS][cliDEFAULT][i]) then
        cli_error("Invalid syntax. Expected an argument after "&Command_Line[OPTIONS][cliFLAG][nn]&".")
      end if

      nn = find(cl[i],Command_Line[OPTIONS][cliFLAG])
      if not nn then cli_error("Invalid switch.") end if
      params[cliFLAG][nn] = TRUE
      if atom(params[cliPARAM][nn]) then params[cliPARAM][nn] = {} end if
      params[cliPARAM][nn] &={ cl[i][length(Command_Line[OPTIONS][cliFLAG][nn])+1..length(cl[i])] }
    elsif nn and not length(Command_Line[OPTIONS][cliPARAM][nn+1]) then
      nn += 1
      params[cliFLAG][nn] = TRUE
      params[cliPARAM][nn] = cl[i]
    else -- text param
      if not n then cli_error("Invalid syntax. Expected a text parameter.") end if
      nn = n
      n = 0
      for j = nn+1 to length(Command_Line[OPTIONS][cliFLAG]) do
        if Command_Line[OPTIONS][cliFLAG][j][1] != '-' then
          if length(Command_Line[OPTIONS][cliPARAM][j]) then
            n = j
            exit
          end if
        end if
      end for
      params[cliFLAG][nn] = TRUE
      params[cliPARAM][nn] = cl[i]
      nn = 0
    end if
  end for
  if nn and (length(Command_Line[OPTIONS][cliFLAG]) > nn) then
    if not length(Command_Line[OPTIONS][cliPARAM][nn+1]) then
      if atom(Command_Line[OPTIONS][cliDEFAULT][nn+1]) then
        cli_error("Invalid syntax. Expected an argument after "&Command_Line[OPTIONS][cliFLAG][nn]&".")
      end if
    end if
  end if
  for i = 1 to length(params[cliFLAG]) do
    if not params[cliFLAG][i] then
      if equal(Command_Line[OPTIONS][cliDEFAULT][i], CLI_REQUIRED) then
        cli_error(sprintf("%s parameter is required!",Command_Line[OPTIONS][cliFLAG][i]))
      end if
    end if
  end for
  if help_flag then
    if length(cl) < 3 then cli_show_help() end if
  end if
  return params
end function

-----------------------------------------------------------------------------
-- TEST CODE -- updated for latest version 2/07

 --~ cli_set_description("This is a test of the CLI api")
 --~ cli_set_option("/y",    FALSE, "Yea, sure")
 --~ constant
  --~ FLAG3 = cli_enum_option("/label",    FALSE, "A labelled switch")
  --~ ,FLAG4 = cli_enum_option("/l",  FALSE, "use library,"&LF
                         --~ &"the next token specifies the path to the library")
  --~ ,FLAG5 = cli_enum_option("library",    CLI_REQUIRED, "") -- second part of /l param
  --~ , FLAG1 = cli_enum_option("source",    CLI_REQUIRED, "The file to do stuff to")
  --~ ,FLAG2 = cli_enum_option("destination",   FALSE, "Where to put the file that we did stuff to")
  
 --~ constant CLI = cli_get_options(YES)
 --~ cli_show_help()

--notes from a tester, not the author
--things to test, if you have a -v version, is source CLI_REQUIRED still required?
--can you have options anywhere, how to specify next param required if use /l
--seems to need a REQUIRED_IF
--seems to be impossible to ignore options or missing options if use std-cli
--can cli decide if is bind or trranslated and which euphoria called it if not?


